openapi: 3.0.0
info:
  title: POLYGLOT API
  version: 0.0.1
servers:
  - url: http://localhost:8080/poly
    description: Server
paths:
  /notebook/{notebook_id}:
    get:
      summary: Открыть заданный ноутбук
      tags:
        - Notebook
      operationId: getNotebookById
      parameters:
          - name: id
            in: path
            required: true
            description: Идегтификатор ноутбука
            schema:
              type: string
      responses:
        '200':
          description: Успешный ответ открытия ноутбука
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: '#/components/schemas/Notebook_struct'
        default:
            description: Любая неожиданная ошибка
            content:
              application/json;charset=UTF-8:
                schema:
                  $ref: "#/components/schemas/Error"

    delete:
      summary: Метод удаления ноутбука
      operationId: deleteNotebookById
      tags:
        - Notebook
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
      responses:
        '200':
          "description": Успешное удаление
          content: {}       
        default:
            description: Любая неожиданная ошибка
            content:
              application/json;charset=UTF-8:
                schema:
                  $ref: "#/components/schemas/Error"   

    patch:
      summary: Метод обновления ноутбука
      operationId: updateNotebook
      tags:
        - Notebook
      requestBody:
        required: true
        content:
          application/json;charset=UTF-8:
            schema:
              $ref: '#/components/schemas/Notebook_struct'
      responses:
        '200':
          "description": Подтверждение успешного изменения
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: '#/components/schemas/Output'
        default:
          description: Любая неожиданная ошибка
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: "#/components/schemas/Error"
  /notebook:
    post:       
      summary: Создание ноутбука
      operationId: createNotebook
      tags:
        - Notebook
      requestBody:
        required: true
        content:
          application/json;charset=UTF-8:
            schema:
              $ref: '#/components/schemas/Note'
      responses:
        '200':
          "description": Подтверждение успешного изменения
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: '#/components/schemas/Output'
        default:
          description: Любая неожиданная ошибка
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: "#/components/schemas/Error"            

  /notebooks:
    get:
      summary: Прогрузить все ноутбуки
      tags:
        - Notebooks
      operationId: getAllNotebooks
      responses:
        '200':
          description: Успешный ответ загрузки
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: "#/components/schemas/Notebooks"
        default:
            description: Любая неожиданная ошибка
            content:
              application/json;charset=UTF-8:
                schema:
                  $ref: "#/components/schemas/Error"

  /notebook/{notebook_id}/paragraph/{paragraph_id}:
     post:
        summary: Запуск параграфа
        operationId: runParagraph
        tags:
          - Paragraph
        requestBody:
          required: true
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: '#/components/schemas/Paragraph'
        responses:
          '200':
            "description": Подтверждение успешного изменения
            content:
              application/json;charset=UTF-8:
                schema:
                  $ref: '#/components/schemas/Output'
          default:
            description: Любая неожиданная ошибка
            content:
              application/json;charset=UTF-8:
                schema:
                  $ref: "#/components/schemas/Error"
     delete:
      summary: Метод удаления параграфа
      operationId: deleteParagraphById
      tags:
        - Paragraph
      parameters:
        - name: id
          in: path
          required: true
          schema:
            type: string
      responses:
        '200':
          "description": Успешное удаление
          content: {}       
        default:
            description: Любая неожиданная ошибка
            content:
              application/json;charset=UTF-8:
                schema:
                  $ref: "#/components/schemas/Error"    

  /notebook/{notebook_id}/paragraph:                        
    post:       
      summary: Создание параграфа
      operationId: createParagraph
      tags:
        - Paragraph
      responses:
        '200':
          "description": Подтверждение успешного изменения
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: '#/components/schemas/Output'
        default:
          description: Любая неожиданная ошибка
          content:
            application/json;charset=UTF-8:
              schema:
                $ref: "#/components/schemas/Error" 









components:
  schemas:
    Paragraph:
      type: object
      reqiured:
        -paragraph_id
        -language
        -code
      properties: 
        paragraph_id:
          type: string
          example: 123e4567-e89b-12d3-a456-556642440000
        language:
          type: string
          example: python
        code:
          type: string
          example: a = 12
        output:
          type: string
          example: ""
    Note:
      type: object
      reqiured:
        -title
      properties: 
        title:
          type: string
          example: test
    Paragraph_struct:
      type: object
      reqiured:
        -paragraph_id
        -notebook_id
        -language
        -code
      properties: 
        paragraph_id:
          type: string
          example: 123e4567-e89b-12d3-a456-556642440000
        notebook_id:
          type: string
          example: 123e4567-e89b-12d3-a456-556642441111
        language:
          type: string
          example: python
        code:
          type: string
          example: a = 12
        output:
          type: string
          example: ""
    Notebook:
      type: object
      reqiured:
        -notebook_id
        -title
      properties: 
        notebook_id:
          type: string
          description: Идентификатор ноутбука
          example: 123e4567-e89b-12d3-a456-556642441111
        title:
          type: string
          description: Наименование ноутбука
          example: Polyglot_API
        date:
          type: string
          format: date-time
          description: Дата и время последнего изменения
          example: "2021-01-30T08:30:00Z"
    Notebook_struct:
      type: object
      reqiured:
        -notebook_id
        -title
      properties: 
        notebook_id:
          type: string
          description: Идентификатор ноутбука
          example: 123e4567-e89b-12d3-a456-556642441111
        title:
          type: string
          description: Наименование ноутбука
          example: Polyglot_API
        date:
          type: string
          format: date-time
          description: Дата и время последнего изменения
          example: "2021-01-30T08:30:00Z"
        paragraphs:
          type: array
          items:
            $ref: '#/components/schemas/Paragraph'
    Output:
      type: string
    Notebooks:
      type: array
      items:
        $ref: '#/components/schemas/Notebook'
    Paragraphs_struct:
      type: array
      items:
        $ref: '#/components/schemas/Paragraph_struct'
    Error:
      type: object
      required:
        - code
        - message
      properties:
        code:
          type: integer
          format: int32
        message:
          type: string
contentType: yaml
      